/*
 *	clipmath.c
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Sat Dec  1 13:20:55 JST 2001 Naoyuki Sawa
 *	- ϡ
 */
#include "clipstd.h"
#include "clipmath.h"

/*****************************************************************************
 *	꾮
 *****************************************************************************/

FIXED
Fsqrt(FIXED a)
{
	int b, c;
	FIXED d, e;

	/* ʲνǤϡdѲϰϤ0x7FFF1ǡ0ˤϤʤޤ
	 * Τᡢa<=0ξΤߤȽꤷơ0֤ޤ
	 */
	if(a <= 0) return 0;

	/* "d*d>>FIXED_SHIFT"">>FIXED_SHIFT"򤷤ʤƤѤ褦ˡ
	 * ʿͤ¦"<<FIXED_SHIFT"Ƥޤ
	 * ǡη׻"d*d"ǺѤߤޤ
	 */
	b = a << FIXED_SHIFT;

	/* **ͤϤơȾʬŤĵͤƹԤޤ */
	d = (1 << 14); /* 1<<15ǤϤʤȤ! */
	e = (1 << 13);
	do {
		/* ߤͤ褷ơʿͤȳӤ٤ޤ */
		c = d * d; /* :Fmul(d,d)ǤϤޤ! */
		if(c < b) {
			/* ­ʤСäޤ */
			d += e;
		} else if(c > b) {
			/* 礭顢ޤ */
			d -= e;
		} else {
			/* פ顢ꤷޤ */
			break;
		}
	} while((e >>= 1) != 0);

	return d;
}

/* 0(̤)128ʬ䤷ơ֥Ǥ
 * * 꾮ξӥåȤϡ7ӥåȰʲꤷƤޤ
 * * 7ӥåȤȲꤷƤ⡢ͤϰϤ0.0(0x00)1.0(0x80)
 *   ͤ1ХȤ˼ޤΤǡǤFIXED(2Х)ǤϤʤ
 *   FIXEDβ̥ХȤΤ(ʤ)Ȥơ̤󤷤ޤ
 * * ٦С2Фбͤϡ0ФΥǡȿžޤ
 *   ơ֥ͤϡʤǤ뤳ȤդƤ
 */
static const unsigned char sin_table[128] = {
	F(0.000000), F(0.024541), F(0.049068), F(0.073565),
	F(0.098017), F(0.122411), F(0.146730), F(0.170962),
	F(0.195090), F(0.219101), F(0.242980), F(0.266713),
	F(0.290285), F(0.313682), F(0.336890), F(0.359895),
	F(0.382683), F(0.405241), F(0.427555), F(0.449611),
	F(0.471397), F(0.492898), F(0.514103), F(0.534998),
	F(0.555570), F(0.575808), F(0.595699), F(0.615232),
	F(0.634393), F(0.653173), F(0.671559), F(0.689541),
	F(0.707107), F(0.724247), F(0.740951), F(0.757209),
	F(0.773010), F(0.788346), F(0.803208), F(0.817585),
	F(0.831470), F(0.844854), F(0.857729), F(0.870087),
	F(0.881921), F(0.893224), F(0.903989), F(0.914210),
	F(0.923880), F(0.932993), F(0.941544), F(0.949528),
	F(0.956940), F(0.963776), F(0.970031), F(0.975702),
	F(0.980785), F(0.985278), F(0.989177), F(0.992480),
	F(0.995185), F(0.997290), F(0.998795), F(0.999699),
	F(1.000000), F(0.999699), F(0.998795), F(0.997290),
	F(0.995185), F(0.992480), F(0.989177), F(0.985278),
	F(0.980785), F(0.975702), F(0.970031), F(0.963776),
	F(0.956940), F(0.949528), F(0.941544), F(0.932993),
	F(0.923880), F(0.914210), F(0.903989), F(0.893224),
	F(0.881921), F(0.870087), F(0.857729), F(0.844854),
	F(0.831470), F(0.817585), F(0.803208), F(0.788346),
	F(0.773010), F(0.757209), F(0.740951), F(0.724247),
	F(0.707107), F(0.689541), F(0.671559), F(0.653173),
	F(0.634393), F(0.615232), F(0.595699), F(0.575808),
	F(0.555570), F(0.534998), F(0.514103), F(0.492898),
	F(0.471397), F(0.449611), F(0.427555), F(0.405241),
	F(0.382683), F(0.359895), F(0.336890), F(0.313682),
	F(0.290285), F(0.266713), F(0.242980), F(0.219101),
	F(0.195090), F(0.170962), F(0.146730), F(0.122411),
	F(0.098017), F(0.073565), F(0.049068), F(0.024541),
};

FIXED
Fsin(FIXED a)
{
	int i;
	i = 128 * a / FPI & 255;
	return i < 128 ?  sin_table[i      ]
		       : -sin_table[i - 128];
}

FIXED
Fcos(FIXED a)
{
	/* cos() = sin(+/2) */
	return Fsin(a + FPI_2);
}

FIXED
Ftan(FIXED a)
{
	/* tan() = sin() / cos() */
	return Fdiv(Fsin(a), Fcos(a));
}

/*****************************************************************************
 *	٥ȥ
 *****************************************************************************/

/* άˡ */
#define Vx	v.x
#define Vy	v.y
#define Vz	v.z
#define Ax	a.x
#define Ay	a.y
#define Az	a.z
#define Bx	b.x
#define By	b.y
#define Bz	b.z

const VECTOR V0 = {  0,  0,  0 };
const VECTOR VX = { F1,  0,  0 };
const VECTOR VY = {  0, F1,  0 };
const VECTOR VZ = {  0,  0, F1 };

VECTOR
V(FIXED x, FIXED y, FIXED z)
{
	/* * GCCVC++Ǥϡ
	 *	VECTOR v = { x, y, z };
	 *   Ƚ񤯤ȤǤޤν񼰤ANSIߴǤ
	 *   ANSIɸǤϡ¤ΤνҤǤʤФޤ
	 *   Ȥι¤ΤautoѿǤäȤƤ⡢Ǥ
	 * * ºݤˤϡ¤Ϥʤ긷ΤǤꡢ
	 *   GCCǤϡ-ansi˲ä-pedanticץꤷʤ¤ꡢ
	 *   ѥ륨顼Ȥʤ뤳ȤϤޤ
	 *   äդΤǡANSIɸ˽Ȥˤޤ
	 * * Fri Dec  7 04:46:48 JST 2001 Naoyuki Sawa
	 *   äѤĥʸˡȤȤˤޤ餱ޤ^^;
	 */
	VECTOR v = { x, y, z };
	return v;
}

VECTOR
Vneg(VECTOR a)
{
	return V(-Ax,
		 -Ay,
		 -Az);
}

VECTOR
Vadd(VECTOR a, VECTOR b)
{
	return V(Ax + Bx,
		 Ay + By,
		 Az + Bz);
}

VECTOR
Vsub(VECTOR a, VECTOR b)
{
	return V(Ax - Bx,
		 Ay - By,
		 Az - Bz);
}

VECTOR
Vmul(VECTOR a, VECTOR b)
{
	return V(Fmul(Ax, Bx),
		 Fmul(Ay, By),
		 Fmul(Az, Bz));
}

VECTOR
Vdiv(VECTOR a, VECTOR b)
{
	return V(Fdiv(Ax, Bx),
		 Fdiv(Ay, By),
		 Fdiv(Az, Bz));
}

VECTOR
Vmul1(VECTOR a, FIXED b)
{
	return V(Fmul(Ax, b),
		 Fmul(Ay, b),
		 Fmul(Az, b));
}

VECTOR
Vdiv1(VECTOR a, FIXED b)
{
	return V(Fdiv(Ax, b),
		 Fdiv(Ay, b),
		 Fdiv(Az, b));
}

FIXED
Vdot(VECTOR a, VECTOR b)
{
	return Fmul(Ax, Bx) +
	       Fmul(Ay, By) +
	       Fmul(Az, Bz);
}
VECTOR
Vcross(VECTOR a, VECTOR b)
{
	return V(Fmul(Ay, Bz) - Fmul(Az, By),
		 Fmul(Az, Bx) - Fmul(Ax, Bz),
		 Fmul(Ax, By) - Fmul(Ay, Bx));
}

VECTOR
Vnormal(VECTOR a)
{
	return Vdiv1(a, Vmag(a));
}

FIXED
Vmag(VECTOR a)
{
	return Fsqrt(Vmag2(a));
}

FIXED
Vmag2(VECTOR a)
{
	return Vdot(a, a);
}

VECTOR
Vreflect(VECTOR N, VECTOR E)
{
	/* ȿͥ٥ȥθϡ̤Ǥ
	 *	R = 2(EN)N - E
	 */
	return Vsub(Vmul1(N, Vdot(E, N) * 2), E);
	/*                   ~~~~~~~~~~(EN)
	 *                   ~~~~~~~~~~~~~~2(EN)
	 *          ~~~~~~~~~~~~~~~~~~~~~~~~2(EN)N
	 *     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~2(EN)N - E
	 */
}

/*****************************************************************************
 *	
 *****************************************************************************/

/* άˡ */
#define M00	m.e00
#define M01	m.e01
#define M02	m.e02
#define M10	m.e10
#define M11	m.e11
#define M12	m.e12
#define M20	m.e20
#define M21	m.e21
#define M22	m.e22
#define M30	m.e30
#define M31	m.e31
#define M32	m.e32
#define A00	a.e00
#define A01	a.e01
#define A02	a.e02
#define A10	a.e10
#define A11	a.e11
#define A12	a.e12
#define A20	a.e20
#define A21	a.e21
#define A22	a.e22
#define A30	a.e30
#define A31	a.e31
#define A32	a.e32
#define B00	b.e00
#define B01	b.e01
#define B02	b.e02
#define B10	b.e10
#define B11	b.e11
#define B12	b.e12
#define B20	b.e20
#define B21	b.e21
#define B22	b.e22
#define B30	b.e30
#define B31	b.e31
#define B32	b.e32

const MATRIX MI = { F1,  0,  0,
		     0, F1,  0,
		     0,  0, F1,
		     0,  0,  0 };

MATRIX
M(FIXED e00, FIXED e01, FIXED e02,
  FIXED e10, FIXED e11, FIXED e12,
  FIXED e20, FIXED e21, FIXED e22,
  FIXED e30, FIXED e31, FIXED e32)
{
	MATRIX m = {
		e00, e01, e02,
		e10, e11, e12,
		e20, e21, e22,
		e30, e31, e32,
	};
	return m;
}

MATRIX
Mxpose(MATRIX a)
{
	return M(A00, A10, A20,
		 A01, A11, A21,
		 A02, A12, A22,
		   0,   0,   0);
}

MATRIX
Minv(const MATRIX a)
{
	int i, j, k;
	FIXED s, t;

	/* 4x4󤬲2¤4x8()ꤷ
	 * Ⱦʬ򸵹󡢱Ⱦʬñ̹Ȥޤ
	 * Ⱦʬ3ϸ˴ޤޤޤ󤬡(0,0,0,1)TȤޤ
	 *   Ⱦʬ3(6)Ϸ̤˴ޤޤʤΤǡѰդޤ
	 */
	FIXED m[4][7] = {
		{ A00, A01, A02,  0, F1,  0,  0 },
		{ A10, A11, A12,  0,  0, F1,  0 },
		{ A20, A21, A22,  0,  0,  0, F1 },
		{ A30, A31, A32, F1,  0,  0,  0 },
	};

	/* iꤵ... */
	for(i = 0; i < 4; i++) {
		/* m[j=i3][i]ͤ礭jõޤ
		 * ϡ0ʳʤɤǤ⹽ʤΤǤ
		 * 򾮤뤿ˡ礭ͤȤޤ
		 */
		j = i;
		s = Fabs(m[j][i]);
		for(k = j + 1; k < 4; k++) {
			t = Fabs(m[k][i]);
			if(t > s) {
				j = k;
				s = t;
			}
		}
		/* t=0ʤԲĵդǤԤޤ */

		/* ij򴹤ޤ */
		if(i != j) {
			for(k = 0; k < 7; k++) {
				s = m[i][k];
				    m[i][k] = m[j][k];
				              m[j][k] = s;
			}
		}

		/* m[i][i]1ˤʤ褦im[i][i]ǳޤ
		 *	s = Finv(m[i][i]);
		 *	for(j = 0; j < 7; j++) m[i][j] = Fmul(m[i][j], s);
		 * ȤСǺѤߡ®Ǥޤ
		 * 꾮Ǥϱ黻礭ΤǡˡϺΤޤ
		 */
		s = m[i][i];
		for(j = 0; j < 7; j++) m[i][j] = Fdiv(m[i][j], s);

		/* m[j=iʳ][i]0ˤʤ褦im[j][i]ܤưޤ */
		for(j = 0; j < 4; j++) {
			if(j == i) continue;
			s = m[j][i];
			for(k = 0; k < 7; k++) m[j][k] -= Fmul(m[i][k], s);
		}
		/* ǹiꤷޤ */
	}

	/* ȾʬεչˤʤäƤޤ */
	return M(m[0][4], m[0][5], m[0][6],
		 m[1][4], m[1][5], m[1][6],
		 m[2][4], m[2][5], m[2][6],
		 m[3][4], m[3][5], m[3][6]);
}

MATRIX
Minvno(MATRIX a)
{
	/* ľεѴϡ̤Ǥ
	 *	| R |-1 = |      RT |
	 *	| P |     | (-P)*RT |
	 * 
	 *	R  = žʬɽ3x3
	 *	P  = ʿ԰ưʬɽ3٥ȥ
	 *	RT = Ržֹ
	 * Ȥޤ
	 */
	return M(A00, A10, A20,
		 A01, A11, A21,
		 A02, A12, A22,
		 -(Fmul(A30, A00) + Fmul(A31, A01) + Fmul(A32, A02)),
		 -(Fmul(A30, A10) + Fmul(A31, A11) + Fmul(A32, A12)),
		 -(Fmul(A30, A20) + Fmul(A31, A21) + Fmul(A32, A22)));
}

VECTOR
Vxform(VECTOR a, MATRIX b)
{
	return V(Fmul(Ax, B00) + Fmul(Ay, B10) + Fmul(Az, B20) + B30,
		 Fmul(Ax, B01) + Fmul(Ay, B11) + Fmul(Az, B21) + B31,
		 Fmul(Ax, B02) + Fmul(Ay, B12) + Fmul(Az, B22) + B32);
}

MATRIX
Mxform(MATRIX a, MATRIX b)
{
	return M(Fmul(A00, B00) + Fmul(A01, B10) + Fmul(A02, B20),       Fmul(A00, B01) + Fmul(A01, B11) + Fmul(A02, B21),       Fmul(A00, B02) + Fmul(A01, B12) + Fmul(A02, B22),
		 Fmul(A10, B00) + Fmul(A11, B10) + Fmul(A12, B20),       Fmul(A10, B01) + Fmul(A11, B11) + Fmul(A12, B21),       Fmul(A10, B02) + Fmul(A11, B12) + Fmul(A12, B22),
		 Fmul(A20, B00) + Fmul(A21, B10) + Fmul(A22, B20),       Fmul(A20, B01) + Fmul(A21, B11) + Fmul(A22, B21),       Fmul(A20, B02) + Fmul(A21, B12) + Fmul(A22, B22),
		 Fmul(A30, B00) + Fmul(A31, B10) + Fmul(A32, B20) + B30, Fmul(A30, B01) + Fmul(A31, B11) + Fmul(A32, B21) + B31, Fmul(A30, B02) + Fmul(A31, B12) + Fmul(A32, B22) + B32);
}

MATRIX
Mxlate(FIXED x, FIXED y, FIXED z)
{
	return M(F1,  0,  0,
		  0, F1,  0,
		  0,  0, F1,
		  x,  y,  z);
}

MATRIX
Mscale(FIXED x, FIXED y, FIXED z)
{
	return M(x, 0, 0,
		 0, y, 0,
		 0, 0, z,
		 0, 0, 0);
}

MATRIX
Mscale1(FIXED a)
{
	return M(a, 0, 0,
		 0, a, 0,
		 0, 0, a,
		 0, 0, 0);
}

MATRIX
Mrot(FIXED x, FIXED y, FIXED z, FIXED a)
{
	VECTOR A;
	FIXED s, c;
	FIXED C;

	A = Vnormal(V(x, y, z));
	x = A.x, y = A.y, z = A.z;
	s = Fsin(a), c = Fcos(a);
	C = F1 - c;
	return M(Fmul3(x, x, C) +         c , Fmul3(y, x, C) + Fmul(z, s), Fmul3(z, x, C) - Fmul(y, s),
		 Fmul3(x, y, C) - Fmul(z, s), Fmul3(y, y, C) +         c , Fmul3(z, y, C) + Fmul(x, s),
		 Fmul3(x, z, C) + Fmul(y, s), Fmul3(y, z, C) - Fmul(x, s), Fmul3(z, z, C) +         c ,
		                0           ,                0           ,                0           );
}

MATRIX
Mrotx(FIXED a)
{
	/* xžϡ̤Ǥ
	 *	| 1,  0, 0 |
	 *	| 0,  c, s |
	 *	| 0, -s, c |
	 *	| 0,  0, 0 |
	 * 
	 *	c = cos(a)
	 *	s = sin(a)
	 *	a = ž
	 * Ȥޤ
	 */
	FIXED c, s;
	c = Fcos(a);
	s = Fsin(a);
	return M(F1,  0, 0,
		  0,  c, s,
		  0, -s, c,
		  0,  0, 0);
}

MATRIX
Mroty(FIXED a)
{
	/* yžϡ̤Ǥ
	 *	| c, 0, -s |
	 *	| 0, 1,  0 |
	 *	| s, 0,  c |
	 *	| 0, 0,  0 |
	 * 
	 *	c = cos(a)
	 *	s = sin(a)
	 *	a = ž
	 * Ȥޤ
	 */
	FIXED c, s;
	c = Fcos(a);
	s = Fsin(a);
	return M(c,  0, -s,
		 0, F1,  0,
		 s,  0,  c,
		 0,  0,  0);
}

MATRIX
Mrotz(FIXED a)
{
	/* zžϡ̤Ǥ
	 *	|  c, s, 0 |
	 *	| -s, c, 0 |
	 *	|  0, 0, 1 |
	 *	|  0, 0, 0 |
	 * 
	 *	c = cos(a)
	 *	s = sin(a)
	 *	a = ž
	 * Ȥޤ
	 */
	FIXED c, s;
	c = Fcos(a);
	s = Fsin(a);
	return M( c, s,  0,
		 -s, c,  0,
		  0, 0, F1,
		  0, 0,  0);
}

MATRIX
Mrotxyz(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul (   cB,cC)             ,Fmul (   cB,sC)            ,       -sB ,
		 Fmul3(sA,sB,cC)+Fmul(cA,-sC),Fmul3(sA,sB,sC)+Fmul(cA,cC),Fmul(sA,cB),
		 Fmul3(cA,sB,cC)-Fmul(sA,-sC),Fmul3(cA,sB,sC)-Fmul(sA,cC),Fmul(cA,cB),
		                            0,                          0,          0);
}

MATRIX
Mrotxzy(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul (     cB,cC)            ,         sB ,Fmul (     cB,-sC)            ,
		 Fmul3( cA,-sB,cC)+Fmul(sA,sC),Fmul( cA,cB),Fmul3( cA,-sB,-sC)+Fmul(sA,cC),
		 Fmul3(-sA,-sB,cC)+Fmul(cA,sC),Fmul(-sA,cB),Fmul3(-sA,-sB,-sC)+Fmul(cA,cC),
		                             0,           0,                             0);
}

MATRIX
Mrotyxz(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul(cA,    cC)+Fmul3(-sA,-sB,-sC),Fmul(cA,   sC)+Fmul3(-sA,-sB,cC),Fmul(-sA,cB),
		 Fmul(   cB,-sC)                   ,Fmul(   cB,cC)                  ,         sB ,
		 Fmul(sA,    cC)+Fmul3( cA,-sB,-sC),Fmul(sA,   sC)+Fmul3( cA,-sB,cC),Fmul( cA,cB),
		                                  0,                            0,              0);
}

MATRIX
Mrotyzx(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul(cA, cB),Fmul3(cA,sB,cC)+Fmul(-sA,   -sC),Fmul3(cA,sB,sC)+Fmul(-sA,   cC),
		         -sB ,                Fmul(    cB, cC),                Fmul(    cB,sC),
		 Fmul(sA, cB),Fmul3(sA,sB,cC)+Fmul( cA,   -sC),Fmul3(sA,sB,sC)+Fmul( cA,   cC),
		            0,                               0,                              0);
}

MATRIX
Mrotzxy(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul( cA,   cC)+Fmul3(sA,sB,sC),Fmul(sA, cB),Fmul( cA,   -sC)+Fmul3(sA,sB,cC),
		 Fmul(-sA,   cC)+Fmul3(cA,sB,sC),Fmul(cA, cB),Fmul(-sA,   -sC)+Fmul3(cA,sB,cC),
		 Fmul(    cB,sC)                ,        -sB ,Fmul(    cB, cC)                ,
		                               0,          0 ,                               0);
}

MATRIX
Mrotzyx(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul( cA,cB),Fmul(sA,    cC)+Fmul3( cA,-sB,-sC),Fmul(sA,sC)+Fmul3( cA,-sB,cC),
		 Fmul(-sA,cB),Fmul(cA,    cC)+Fmul3(-sA,-sB,-sC),Fmul(cA,sC)+Fmul3(-sA,-sB,cC),
		          sB ,Fmul(   cB,-sC)                   ,Fmul(cB,cC)                  ,
		            0,                                 0,                            0);
}

MATRIX
Mrotxyx(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(        cB ,Fmul(    -sB,-sC)                 ,Fmul(    -sB,cC)                ,
		 Fmul(sA,sB),Fmul( cA,     cC)+Fmul3(sA,cB,-sC),Fmul( cA,    sC)+Fmul3(sA,cB,cC),
		 Fmul(cA,sB),Fmul(-sA,     cC)+Fmul3(cA,cB,-sC),Fmul(-sA,    sC)+Fmul3(cA,cB,cC),
		           0,                                 0,                               0);
}

MATRIX
Mrotxzx(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(          cB ,                 Fmul(   sB, cC),                 Fmul(   sB,sC),
		 Fmul( cA,-sB),Fmul3( cA,cB,cC)+Fmul(sA,   -sC),Fmul3( cA,cB,sC)+Fmul(sA,   cC),
		 Fmul(-sA,-sB),Fmul3(-sA,cB,cC)+Fmul(cA,   -sC),Fmul3(-sA,cB,sC)+Fmul(cA,   cC),
		             0,                               0,                              0);
}

MATRIX
Mrotyxy(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul(cA,   cC)+Fmul3(-sA,cB,sC),Fmul(-sA,-sB),Fmul(cA,   -sC)+Fmul3(-sA,cB,cC),
		 Fmul(   sB,sC)                 ,          cB ,Fmul(   sB, cC)                 ,
		 Fmul(sA,   cC)+Fmul3( cA,cB,sC),Fmul( cA,-sB),Fmul(sA,   -sC)+Fmul3( cA,cB,cC),
		                               0,            0,                               0);
}

MATRIX
Mrotyzy(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul3(cA,cB,cC)+Fmul(-sA,    sC),Fmul(cA,sB),Fmul3(cA, cB,-sC)+Fmul(-sA,     cC),
		                 Fmul(    -sB,cC),        cB ,                  Fmul(    -sB,-sC),
		 Fmul3(sA,cB,cC)+Fmul( cA,    sC),Fmul(sA,sB),Fmul3(sA, cB,-sC)+Fmul( cA,     cC),
		                                0,          0,                                  0);
}

MATRIX
Mrotzxz(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul( cA,     cC)+Fmul3(sA,cB,-sC),Fmul( cA,    sC)+Fmul3(sA,cB,cC),Fmul(sA,sB),
		 Fmul(-sA,     cC)+Fmul3(cA,cB,-sC),Fmul(-sA,    sC)+Fmul3(cA,cB,cC),Fmul(cA,sB),
		 Fmul(    -sB,-sC)                 ,Fmul(    -sB,cC)                ,        cB ,
		                                  0,                               0,          0);
}

MATRIX
Mrotzyz(FIXED a, FIXED b, FIXED c)
{
	FIXED cA = Fcos(a), sA = Fsin(a);
	FIXED cB = Fcos(b), sB = Fsin(b);
	FIXED cC = Fcos(c), sC = Fsin(c);
	return M(Fmul3( cA,cB,cC)+Fmul(sA,   -sC),Fmul3( cA,cB,sC)+Fmul(sA,   cC),Fmul( cA,-sB),
		 Fmul3(-sA,cB,cC)+Fmul(cA,   -sC),Fmul3(-sA,cB,sC)+Fmul(cA,   cC),Fmul(-sA,-sB),
		                  Fmul(   sB, cC),                 Fmul(   sB,sC),          cB ,
		                                0,                              0,            0);
}

#if 0
FIXED
Mrotget(const MATRIX* I,
	VECTOR* O)
{
	/* ̤ǧ */
	FIXED d, s;
	d = acos((I00 + I11 + I22 - 1) / 2);
	if(d != 0) {
		s = 2 * sin(d);
		mxv_vector_init(O,
			(I12 - I21) / s,
			(I20 - I02) / s,
			(I01 - I10) / s);
	} else {
		mxv_vector_init(O, 0, 0, 1);
	}
	return d;
}
#endif

MATRIX
Morient(FIXED dx, FIXED dy, FIXED dz,
	FIXED ux, FIXED uy, FIXED uz)
{
	/* ϡ̤Ǥ
	 *	| rx, ry, rz |
	 *	| ux, uy, uz |
	 *	| dx, dy, dz |
	 *	|  0,  0,  0 |
	 * 
	 *	| rx, ry, rz | = X٥ȥ
	 *	| ux, uy, uz | = Y٥ȥ
	 *	| dx, dy, dz | = Z٥ȥ
	 * Ȥޤ
	 */
	VECTOR r, u, d;

	/* Z٥ȥޤ */
	d = V(dx, dy, dz);
	d = Vnormal(d);

	/* X٥ȥơޤ 
	 * X٥ȥϡY->Z򺸲Ȥʹ
	 * ʤѤǤ
	 */
	u = V(ux, uy, uz);
	r = Vcross(u, d);
	r = Vnormal(r);

	/* Y٥ȥޤ
	 * Y٥ȥϡZ->X򺸲Ȥʹ
	 * ʤѤǤ
	 * ZX٥ȥ뤬ƤΤǡ
	 * Y٥ȥŪɬפϤޤ
	 */
	u = Vcross(d, r);

	return M(r.x, r.y, r.z,
		 u.x, u.y, u.z,
		 d.x, d.y, d.z,
		   0,   0,   0);
}

MATRIX
Mlookat(FIXED ex, FIXED ey, FIXED ez,
	FIXED cx, FIXED cy, FIXED cz,
	FIXED bank)
{
	/* 鼫ȤưɽѴϡ̤Ǥ
	 * 1. Х󥯤롣
	 * 2. γ٤򡢻ɸɸؤθȤ롣
	 * 3. ɸذư롣
	 * ѴϡꤷưΤǡ
	 * 13εѴȤʤޤ
	 */
	MATRIX m;
	m =           Mrotz(bank);
	m = Mxform(m, Morient(cx - ex, cy - ey, cz - ez, 0, 1, 0));
	m = Mxform(m, Mxlate(ex, ey, ez));
	m = Minvno(m);
	return m;
}

MATRIX
Mfrustum(FIXED width, FIXED height, FIXED front)
{
	/* Ʃƹϡ̤Ǥ
	 *	| 2*front/width,              0,                        0, 0 |
	 *	|             0, 2*front/height,                        0, 0 |
	 *	|             0,              0,        back/(back-front), 1 |
	 *	|             0,              0, -front*back/(back-front), 0 |
	 * ǤZɸʤΤǡ
	 *	| 2*front/width,              0, 0 |
	 *	|             0, 2*front/height, 0 |
	 *	|             0,              0, 1 |
	 *	|             0,              0, 0 |
	 * Ȥޤ
	 *	width  = ̤
	 *	height = ̤ι⤵
	 *	front  = եȥåԥ󥰵Υ
	 *	back   = Хåեåԥ󥰵Υ
	 * Ǥ
	 */
	return M(Fdiv(2*front,width),                    0,  0,
		                   0, Fdiv(2*front,height),  0,
		                   0,                    0, F1,
		                   0,                    0,  0);
}

MATRIX
Mperspective(FIXED fovy, FIXED aspect, FIXED front)
{
	FIXED width, height;
	height = Fmul(front, Ftan(fovy / 2)) * 2; /* ̤   */
	width  = Fmul(height, aspect);            /* ̤ι⤵ */
	return Mfrustum(width, height, front);
}

MATRIX
Mviewport(int left, int top, int width, int height)
{
	/* ɸ(x,y)
	 *	x = :-11:
	 *	y = :-11:
	 * 顢ӥ塼ݡȺɸ(X,Y)
	 *	X = :left      left+width:
	 *	Y = :top+height       top:
	 * ؤѴˤĤơޤ
	 *
	 * 1) ǥѴ->Ѵ->ƩѴ->x=x/z,y=y/z->ӥ塼ݡѴ
	 *    Ȥξ...
	 * Ѵϡ̤Ǥ
	 *	X = left + (x + 1) *  width  / 2 = ( width  / 2) * x + (left + width  / 2)
	 *	Y = top  + (y - 1) * -height / 2 = (-height / 2) * y + (top  + height / 2)
	 * äơӥ塼ݡѴϡ̤Ǥ
	 *	|      width/2,            0, 0 |
	 *	|            0,    -height/2, 0 |
	 *	|            0,            0, 1 |
	 *	| left+width/2, top+height/2, 0 |
	 *
	 * 2) ǥѴ->Ѵ->ƩѴ->ӥ塼ݡѴ->x=x/z,y=y-z
	 *    Ȥξ...
	 * ʬˤ1/zƶƤޤȤ򤢤餫θơ
	 *	X = ( width  / 2) * x + (left + width  / 2) * z
	 *	Y = (-height / 2) * y + (top  + height / 2) * z
	 * äơӥ塼ݡѴϡ̤Ǥ
	 *	|      width/2,            0, 0 |
	 *	|            0,    -height/2, 0 |
	 *	| left+width/2, top+height/2, 1 |
	 *	|            0,            0, 0 |
	 */
	return M(F(     width/2),               0,  0,
		               0, F(   -height/2),  0,
		               0,               0, F1,
		 F(left+width/2), F(top+height/2),  0);
}

MATRIX
Mviewportz(int left, int top, int width, int height)
{
	/* Mviewport()ΥȤ򻲾ȤƤ */
	return M(F(     width/2),               0,  0,
		               0, F(   -height/2),  0,
		 F(left+width/2), F(top+height/2), F1,
		               0,               0,  0);
}

MATRIX
Mshadow(FIXED Lx, FIXED Ly, FIXED Lz,
	FIXED Gx, FIXED Gy, FIXED Gz,
	FIXED Nx, FIXED Ny, FIXED Nz)
{
	/*	P = Ƥɸ
	 *	L = ٥ȥ
	 *	G = ̤ΰ
	 *	N = ̤ˡ
	 * ФơƤ줿ɸSˡϡ̤Ǥ
	 * 餫ᡢ
	 *	LN = LN
	 *	GN = GN
	 *	A  = Lx / LN
	 *	B  = Ly / LN
	 *	C  = Lz / LN
	 * Ƥ
	 *	Sx = Px*(1 - Nx*A) + Py*(  - Ny*A) + Pz(  - Nz*A) + GN*A
	 *	Sy = Px*(  - Nx*B) + Py*(1 - Ny*B) + Pz(  - Nz*B) + GN*B
	 *	Sz = Px*(  - Nx*C) + Py*(  - Ny*C) + Pz(1 - Nz*C) + GN*C
	 * äơ
	 *	| 1-Nx*A,  -Nx*B,  -Nx*C |
	 *	|  -Ny*A, 1-Ny*B,  -Ny*C |
	 *	|  -Nz*A,  -Nz*B, 1-Nz*C |
	 *	| GN  *A, GN  *B, GN  *C |
	 * Ȥʤޤ
	 */
	VECTOR L, G, N;
	FIXED LN, GN;
	FIXED A, B, C;
	L = V(Lx, Ly, Lz);
	G = V(Gx, Gy, Gz);
	N = V(Nx, Ny, Nz);
	LN = Vdot(L, N);
	GN = Vdot(G, N);
	A = Fdiv(L.x, LN);
	B = Fdiv(L.y, LN);
	C = Fdiv(L.z, LN);
	return M(1-Fmul(N.x,A),  -Fmul(N.x,B),  -Fmul(N.x,C),
		  -Fmul(N.y,A), 1-Fmul(N.y,B),  -Fmul(N.y,C),
		  -Fmul(N.z,A),  -Fmul(N.z,B), 1-Fmul(N.z,C),
		   Fmul(GN ,A),   Fmul(GN ,B),   Fmul(GN ,C));
}

FIXED
Fbezier(FIXED t, FIXED Q0, FIXED Q1, FIXED Q2)
{
	/* ٥ϡ̤Ǥ
	 *	P(t) = |t^2 t 1|| 1 -2  1||Q0|
	 *			|-2  2  0||Q1|
	 *			| 1  0  0||Q2|
	 * 
	 *	t: ѥȥåѿ(01)
	 *	Q0: ȥݥ#0κɸ
	 *	Ql:                     #1
	 *	Q2:                     #2
	 * Ȥޤ
	 */
	FIXED t2 = Fsqu(t);
	return Fmul(t2* 1 + t*-2 + 1*1, Q0) + /* 꾮*ʬFmul */
	       Fmul(t2*-2 + t* 2 + 1*0, Q1) +
	       Fmul(t2* 1 + t* 0 + 1*0, Q2);
}

FIXED
Fhermite(FIXED t, FIXED Q0, FIXED Q1, FIXED Q0d, FIXED Q1d)
{
	/* ߡȶϡ̤Ǥ
	 *	P(t) = |t^3 t^2 t 1|| 2 -2  1  1||Q0 |
	 *			    |-3  3 -2 -1||Q1 |
	 *			    | 0  0  1  0||Q0'|
	 *			    | 1  0  0  0||Q1'|
	 * 
	 *	t: ѥȥåѿ(01)
	 *	Q0: ȥݥ#0κɸ
	 *	Ql:                     #1
	 *	Q0': ȥݥ#0ˤ٥ȥ
	 *	Ql':                     #1
	 * Ȥޤ
	 */
	FIXED t2 = Fsqu(t);
	FIXED t3 = Fmul(t2, t);
	return Fmul(t3* 2 + t2*-3 + t*0 + 1*1, Q0 ) + /* 꾮*ʬFmul */
	       Fmul(t3*-2 + t2* 3 + t*0 + 1*0, Q1 ) +
	       Fmul(t3* 1 + t2*-2 + t*1 + 1*0, Q0d) +
	       Fmul(t3* 1 + t2*-1 + t*0 + 1*0, Q1d);
}

#if 0
int
mxv_point_in_polygon(FIXED px, FIXED py, FIXED points[/*n_points*/][2], int n_points)
{
	/* * ޷̷ʤСѤȤˡ⤢ޤ
	 *   ϡ޷̷ξˤбǤˡǼޤ
	 * * δؿFIXEDѤȤʤäƤޤˤ񤤤褦ˡ
	 *   СեкȤäƤΤǡ
	 *   Τޤ޲autoѿFIXED->intѹС
	 *   intѤδؿ뤳ȤǤޤ
	 *   ߤΤȤޤintѴؿɬפʤᡢäƤޤ
	 *
	 *--------------------------------------------------------------------
	 *
	 * (px,py)޷¦ˤ뤫ɤĴ٤ˡ:
	 *
	 * (px,py)ȤȾľȡ޷γդθ򺹤Ĵ١
	 * 򺹤դοĤʤС(px,py)Ͽ޷¦Ǥ
	 *
	 * Ⱦľϡμɽޤ
	 *	x = px + At	| (A, B): Ⱦľηɽ٥ȥ
	 *	y = py + Bt	| 0 <= t
	 * ޷Τդϡμɽޤ
	 *	x = x0 + Cu	| C = x1 - x0, D = y1 - y0
	 *	y = y0 + Du	| 0 <= u < 1
	 *			|  0<=u<=1Ȥʤͳϡ
	 *			|    Ⱦľ礦ĺ̤硢
	 *			|    0<=u<=1Ǥϡ٤礦Ĥդξ
	 *			|    򺹤ȽꤵƤޤǤ
	 *			|    ξ硢޷¦餢ĺ
	 *			|    ̤äƳȴȾľäˡ
	 *			|    ޷¦Ǥˤ⤫餺
	 *			|    2Ȥʤꡢ¦ȽǤޤ
	 *			|    δְ㤤ɤˡ
	 *			|    0<=u<=1ǤϤʤ0<=u<1ȤƤޤ
	 * (x,y)Ȥȡ
	 *	x = px + At = x0 + Cu
	 *	y = py + Bt = y0 + Du
	 * ϢΩ򤤤ơt,uޤ
	 *	At - Cu = x0 - px
	 *	Bt - Du = y0 - py
	 *	t = (D(x0 - px) - C(y0 - py)) / (AD - BC)
	 *	u = (B(x0 - px) - A(y0 - py)) / (AD - BC)
	 *	t = (DE - CF) / (AD - BC)	| E = x0 - px
	 *	u = (BE - AF) / (AD - BC)	| F = y0 - py
	 * ơȾľηǤդ֤ȤǤΤǡ
	 * ñΤ˿ʿȤޤ
	 *	(A, B) = (1, 0)
	 *	t = (DE - CF) / D
	 *	u = ( 0 -  F) / D
	 * t,uξꡢ
	 *	0 <= (DE - CF) / D
	 *	0 <= ( 0 -  F) / D < 1
	 * D0˶ᤤȡ̤礭ʤꡢСեȯ
	 * 뤿ᡢξդD򤫤ƽʤޤ
	 *	D >= 0ξ	| D < 0ξ
	 *	----------------+-------------
	 *	0 <= DE - CF	| 0 >= DE - CF	... 1
	 *	0 <= -F < D	| 0 >= -F > D	... 2
	 * 1,2ΩСȾľդϸ򺹤ޤ
	 * Ƚ޷դοԤ򺹤դʤ
	 * ꤵ줿Ͽ޷¦Ȥʤޤ
	 *
	 *--------------------------------------------------------------------
	 */

	int n_cross, i;
	FIXED x0, y0, x1, y1, C, D, E, F;

	assert(n_points >= 3);

	/* ޤꥢ */
	n_cross = 0;

	/* ǽդλϡǸĺȤޤ */
	x0 = points[n_points - 1][0];
	y0 = points[n_points - 1][1];
	for(i = 0; i < n_points; i++) {
		/* դνޤ */
		x1 = points[i][0];
		y1 = points[i][1];

		/* Ƚꡣ */
		C = x1 - x0;
		D = y1 - y0;
	 	E = x0 - px;
		F = y0 - py;
		if(D >= 0) {
			if(0 <= D * E - C * F &&
			   0 <= -F && -F < D) n_cross++;
		} else {
			if(0 >= D * E - C * F &&
			   0 >= -F && -F > D) n_cross++;
		}

		/* դλϡդνǤ */
		x0 = x1;
		y0 = y1;
	}

	/* ʤ¦Ǥ */
	return n_cross & 1;
}

FIXED
mxv_point_to_line_s(const VECTOR* p, const VECTOR* a, const VECTOR* da)
{
	/*  p ľ a + da ؿ򲼤֤ q Ȥ롣
	 * p  q ؤΥ٥ȥȡda ľ򤹤Τǡ
	 *	(q - p)da = 0		1
	 * q  ľˤΤǡ
	 *	q = a + da		2
	 * 1,2
	 *	(a + da - p)da = 0
	 *	 = da(p - a) / dada
	 * : ʬʬҤ˸ da ϡñʤǤϤʤѤʤΤǡ
	 *       ʬʬҤ da ǳä (p - a) / da ˤƤϤʤ
	 *	 Ǥϡ٥ȥ٥ȥˤʤäƤޤ
	 *	 ʬʬҤ˶̤Ѥ껦뤳ȤΤɤ狼ʤ
	 *	 ʤȤͤϥ٥ȥ٥ȥη׻ˡΤʤ
	 */
	VECTOR ap;
	mxv_vector_sub(&ap, p, a);
	return mxv_vector_dot_product(da, &ap) / mxv_vector_square_magnitude(da);
}

int
mxv_polygon_orientation(FIXED points[/*n_points*/][2], int n_points)
{
	/* ޷εҤȲꤷơ٤ιפä硢
	 * (޷γ٤ι)ʤ顢(n_points-2) Ȥʤޤ
	 * (޷γ٤ι)ʤ顢(n_points+2) Ȥʤޤ
	 * ̩ˤϡפ (n_points-2) ĶǵȽǤǤϤǤ
	 * 黻ΤᡢǤפ (n_point-2)+ Ȥʤǽޤ
	 * ǡΤˡξԤ֤ˤͤäơ
	 * n_points ĶǵȽǤ뤳Ȥˤޤ 
	 *
	 * <<Ķ!!>
	 * v01v12γ٤ϤΤǤϤʤv10v12γ٤Ϥ뤳Ȥ!
	 * ĤդѤκϤΤǤϤʤĺ1ΤȤγ٤ϤΤǤ
	 * ⤷v01v12γ٤ϤäƤޤȡ㤨жü򤢤ʤ顢
	 * Ĥ٤äդľˤ硢δ֤γ٤餫180٤Ǥ
	 * ְä0٤ȤʤäƤޤޤ
	 */
	FIXED x0, y0, x1, y1, x2, y2, x10, x12, y10, y12, dx, dy;
	FIXED threshold, d, d_sum;
	int i;

	assert(n_points >= 3);

	/* ͤޤ */
	threshold = n_points * MXV_PI;

	d_sum = 0;
	for(i = 0; i < n_points; i++) {
		/* v10=(x10,y10), v12=(x12,y12) ޤ */
		x0 = points[(i + 0) % n_points][0];
		y0 = points[(i + 0) % n_points][1];
		x1 = points[(i + 1) % n_points][0];
		y1 = points[(i + 1) % n_points][1];
		x2 = points[(i + 2) % n_points][0];
		y2 = points[(i + 2) % n_points][1];
		x10 = x0 - x1;
		y10 = y0 - y1;
		x12 = x2 - x1;
		y12 = y2 - y1;

		/* : dx = |v10||v12|cos */
		dx = x10 * x12 + y10 * y12;

		/* : dy = |v10||v12|sin */
		dy = x10 * y12 - x12 * y10;

		/* v10v12γ٤ 02 ϰϤǵޤ
		 * : atan2() -С ϰϤ֤ޤ
		 */
		d = atan2(dy, dx);
		if(d < 0) d += MXV_PI2;

		/* ٤­ơͤĶǤ */
		d_sum += d;
		if(d_sum > threshold) return 1;
	}

	/* ǸޤǤͤĶʤСǤ */
	return 0;
}
#endif

