/*
 *	field.c
 */
#include "app.h"

#define FALL_SPEED	4

/* Aj[Vp^[ */
typedef struct _ANMTBL {
	short normal;		/* ʏ */
	short bounce[3];	/* n */
	short erase[2];		/*  */
	short diatom[2];	/*  */
} ANMTBL;
static ANMTBL anmtbl[6][3] = {
	/*  */
	{{CHR_SNG10,{CHR_SNG11,CHR_SNG12,CHR_SNG11},{CHR_SNG13,CHR_SNG14},{0,0}},
	 {CHR_HRZ10,{CHR_HRZ11,CHR_HRZ12,CHR_HRZ11},{CHR_HRZ13,CHR_HRZ14},{CHR_HRZ15,CHR_HRZ16}},
	 {CHR_VRT10,{CHR_VRT11,CHR_VRT12,CHR_VRT11},{CHR_VRT13,CHR_VRT14},{CHR_VRT15,CHR_VRT16}}},
	/*  */
	{{CHR_SNG20,{CHR_SNG21,CHR_SNG22,CHR_SNG21},{CHR_SNG23,CHR_SNG24},{0,0}},
	 {CHR_HRZ20,{CHR_HRZ21,CHR_HRZ22,CHR_HRZ21},{CHR_HRZ23,CHR_HRZ24},{CHR_HRZ25,CHR_HRZ26}},
	 {CHR_VRT20,{CHR_VRT21,CHR_VRT22,CHR_VRT21},{CHR_VRT23,CHR_VRT24},{CHR_VRT25,CHR_VRT26}}},
	/*  */
	{{CHR_SNG30,{CHR_SNG31,CHR_SNG32,CHR_SNG31},{CHR_SNG33,CHR_SNG34},{0,0}},
	 {CHR_HRZ30,{CHR_HRZ31,CHR_HRZ32,CHR_HRZ31},{CHR_HRZ33,CHR_HRZ34},{CHR_HRZ35,CHR_HRZ36}},
	 {CHR_VRT30,{CHR_VRT31,CHR_VRT32,CHR_VRT31},{CHR_VRT33,CHR_VRT34},{CHR_VRT35,CHR_VRT36}}},
	/*  */
	{{CHR_SNG40,{CHR_SNG41,CHR_SNG42,CHR_SNG41},{CHR_SNG43,CHR_SNG44},{0,0}},
	 {CHR_HRZ40,{CHR_HRZ41,CHR_HRZ42,CHR_HRZ41},{CHR_HRZ43,CHR_HRZ44},{CHR_HRZ45,CHR_HRZ46}},
	 {CHR_VRT40,{CHR_VRT41,CHR_VRT42,CHR_VRT41},{CHR_VRT43,CHR_VRT44},{CHR_VRT45,CHR_VRT46}}},
	/* L */
	{{CHR_SNG50,{CHR_SNG51,CHR_SNG52,CHR_SNG51},{CHR_SNG53,CHR_SNG54},{0,0}},
	 {0,{0,0,0},{0,0},{0,0}},
	 {0,{0,0,0},{0,0},{0,0}}},
	/* X */
	{{CHR_SNG60,{CHR_SNG61,CHR_SNG62,CHR_SNG61},{CHR_SNG63,CHR_SNG64},{0,0}},
	 {0,{0,0,0},{0,0},{0,0}},
	 {0,{0,0,0},{0,0},{0,0}}},
};

/****************************************************************************
 *	cell_draw
 ****************************************************************************/

static int
cell_draw(int spr, int x, int y, CELL* cell)
{
	ANMTBL* anm;

	if(cell->color != CC_BLANK) {
		switch(cell->type) {
		case CT_SINGLE:
			anm = &anmtbl[cell->color - 1][0];
			switch(cell->mode) {
			case CM_STOP:
				spr = sprite_block(spr, x, y, anm->normal, 1, 1);
				break;
			case CM_FALL:
				spr = sprite_block(spr, x, y - 6 + cell->count, anm->normal, 1, 1);
				break;
			case CM_BOUNCE:
				spr = sprite_block(spr, x, y, anm->bounce[(int)cell->count], 1, 1);
				break;
			case CM_ERASE:
				spr = sprite_block(spr, x, y, anm->erase[(int)cell->count], 1, 1);
				break;
			case CM_DIATOM:
				spr = sprite_block(spr, x, y, anm->diatom[(int)cell->count], 1, 1);
				break;
			default:
				DIE();
			}
			break;
		case CT_LEFT:
			anm = &anmtbl[cell->color - 1][1];
			switch(cell->mode) {
			case CM_STOP:
				spr = sprite_block(spr, x, y, anm->normal, 2, 1);
				break;
			case CM_FALL:
				spr = sprite_block(spr, x, y - 6 + cell->count, anm->normal, 2, 1);
				break;
			case CM_BOUNCE:
				spr = sprite_block(spr, x, y, anm->bounce[(int)cell->count], 2, 1);
				break;
			case CM_ERASE:
				spr = sprite_block(spr, x, y, anm->erase[(int)cell->count], 2, 1);
				break;
			case CM_DIATOM:
				spr = sprite_block(spr, x, y, anm->diatom[(int)cell->count], 2, 1);
				break;
			default:
				DIE();
			}
			break;
		case CT_RIGHT:
			/* ܂B */
			break;
		case CT_UPPER:
			anm = &anmtbl[cell->color - 1][2];
			switch(cell->mode) {
			case CM_STOP:
				spr = sprite_block(spr, x, y, anm->normal, 1, 2);
				break;
			case CM_FALL:
				spr = sprite_block(spr, x, y - 6 + cell->count, anm->normal, 1, 2);
				break;
			case CM_BOUNCE:
				spr = sprite_block(spr, x, y, anm->bounce[(int)cell->count], 1, 2);
				break;
			case CM_ERASE:
				spr = sprite_block(spr, x, y, anm->erase[(int)cell->count], 1, 2);
				break;
			case CM_DIATOM:
				spr = sprite_block(spr, x, y, anm->diatom[(int)cell->count], 1, 2);
				break;
			default:
				DIE();
			}
			break;
		case CT_UNDER:
			/* ܂B */
			break;
		default:
			DIE();
		}
	} else {
		spr = sprite_clear(spr, 1);
	}
	return spr;
}

/****************************************************************************
 *	quad_draw
 ****************************************************************************/

int
quad_draw(int spr, int x, int y, CELL quad[2][2])
{
	int x_cur, y_cur, col, row;
	CELL* cell;

	for(row = 0, y_cur = y; row < 2; row++, y_cur += 7) {
		for(col = 0, x_cur = x; col < 2; col++, x_cur += 7) {
			cell = &quad[row][col];
			spr = cell_draw(spr, x_cur, y_cur, cell);
		}
	}

	return spr;
}

/****************************************************************************
 *	tB[h\^XN
 ****************************************************************************/

#define FLDINF_FMT "\n" \
		   "%6d\n" \
		   "\n" \
		   "\n" \
		   "%6d\n" \
		   "\n" \
		   "޲ݻ\n" \
		   "%6d\n"

typedef struct _TASKDATA {
	FIELD* field;
} TASKDATA;

static int
field_work(TASK* task)
{
	TASKDATA* data = (TASKDATA*)(task + 1);
	int spr_fld, spr_quad, spr, x_org, y_org, x, y, col, row, count;
	FIELD* field;
	CELL (*cells)[FIELD_COLS], (*quad)[2], *cell;

	/* RpCx}̂߁B */
	spr_fld = 0;
	spr_quad = 0;
	x_org = 0;
	y_org = 0;

	field = data->field;
	switch(field->side) {
	case 0:
		spr_fld = SPR_FLD0;
		spr_quad = SPR_QUAD0;
		x_org = FIELD_X0;
		y_org = FIELD_Y0;
		break;
	case 1:
		spr_fld = SPR_FLD1;
		spr_quad = SPR_QUAD1;
		x_org = FIELD_X1;
		y_org = FIELD_Y1;
		break;
	default:
		DIE();
	}

	/* tB[hZ`܂B */
	spr = spr_fld;
	cells = field->cells;
	for(row = 0, y = y_org; row < FIELD_ROWS; row++, y += 7) {
		for(col = 0, x = x_org; col < FIELD_COLS; col++, x += 7) {
			cell = &cells[row][col];
			spr = cell_draw(spr, x, y, cell);
		}
	}
#if 1
///if((spr - spr_fld) != 8 * 13) die("%d", spr - spr_fld);
#endif

	/* Z`܂B */
	spr = spr_quad;
	quad = field->quad;
	count = Fint(field->count);
	switch(field->mode) {
	case FM_CTRL_FALL:
		for(row = 0; row < 2; row++) {
			for(col = 0; col < 2; col++) {
				cell = &quad[row][col];
				cell->mode = CM_FALL;
				cell->count = count;
			}
		}
		x = x_org + field->x * 7;
		y = y_org + field->y * 7;
		spr = quad_draw(spr, x, y, quad);
		break;
	case FM_CTRL_BOUNCE:
		for(row = 0; row < 2; row++) {
			for(col = 0; col < 2; col++) {
				cell = &quad[row][col];
				if(count < 3) {
					cell->mode = CM_BOUNCE;
					cell->count = count;
				} else {
					cell->mode = CM_STOP;
				}
			}
		}
		x = x_org + field->x * 7;
		y = y_org + field->y * 7;
		spr = quad_draw(spr, x, y, quad);
		break;
	default:
		spr = sprite_clear(spr, 2 * 2);
		break;
	}

	/* tB[h\Ȃ... */
	if(BTST(state, STATE_FLDINF)) {
		switch(field->side) {
		case 0:
			x_org = FLDINF_X0;
			y_org = FLDINF_Y0;
			break;
		case 1:
			x_org = FLDINF_X1;
			y_org = FLDINF_Y1;
			break;
		default:
			DIE();
		}
		bg_printf(1, x_org, y_org, FLDINF_FMT,
			field->ctrl_done,
			field->erase_num,
			field->combo_max);
	}

	return 1;
}

TASK*
t_field(FIELD* field)
{
	TASK* task;
	TASKDATA* data;

	task = task_new(game_task, sizeof(TASKDATA));
	task->work = field_work;

	data = (TASKDATA*)(task + 1);
	data->field = field;

	return task;
}

/****************************************************************************
 *	field_fall_iteration
 ****************************************************************************/

int
field_fall_iteration(FIELD* field)
{
	int result, col, row;
	CELL (*cells)[FIELD_COLS], *cell, *cell_under, *cel2, *cel2_under;

	result = 0;
	cells = field->cells;

	/* * 瑖ƁAǂƗ܂B
	 *   ォ瑖ƁA΂΂Ɨ܂B
	 *   ΂΂ƗقĥŁAォ瑖܂B
	 * * Jnĉ̃ZɈڂA̍s̏ŝŁA
	 *   炩߂̕JEg炵ďĂ܂B()
	 */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &cells[row][col];
			if(cell->color != CC_BLANK) {
				switch(cell->type) {
				case CT_SINGLE:
					switch(cell->mode) {
					case CM_STOP:
						/* ŉsłȂ΁AJn`FbNB */
						if(row < FIELD_ROWS - 1) {
							cell_under = cell + FIELD_COLS;
							/* ̃Z󂫂Ȃ΁AJnB */
							if(cell_under->color == CC_BLANK) {
								cell_under->color = cell->color;
								cell_under->type = cell->type;
								cell_under->mode = CM_FALL;
								cell_under->count = 0;
								cell->color = CC_BLANK;
								result = 1; /*  */
							}
						}
						break;
					case CM_FALL:
						cell->count += FALL_SPEED;
						/* ... */
						if(cell->count >= 7) {
							/* ŉsłȂ΁Ap`FbNB */
							if(row < FIELD_ROWS - 1) {
								cell_under = cell + FIELD_COLS;
								/* ̃Z󂫂Ȃ΁ApB */
								if(cell_under->color == CC_BLANK) {
									cell_under->color = cell->color;
									cell_under->type = cell->type;
									cell_under->mode = CM_FALL;
									cell_under->count = cell->count - 7 - FALL_SPEED; /*()*/
									cell->color = CC_BLANK;
								} else {
									cell->mode = CM_BOUNCE;
									cell->count = 0;
								}
							} else {
								cell->mode = CM_BOUNCE;
								cell->count = 0;
							}
						}
						result = 1; /*  */
						break;
					case CM_BOUNCE:
						cell->count++;
						if(cell->count == 3) {
							cell->mode = CM_STOP;
						}
						result = 1;
						break;
					default:
						DIE();
					}
					break;
				case CT_LEFT:
					switch(cell->mode) {
					case CM_STOP:
						/* ŉsłȂ΁AJn`FbNB */
						if(row < FIELD_ROWS - 1) {
							cel2 = cell + 1;
							cell_under = cell + FIELD_COLS;
							cel2_under = cel2 + FIELD_COLS;
							/* ̃Z󂫂Ȃ΁AJnB */
							if(cell_under->color == CC_BLANK &&
							   cel2_under->color == CC_BLANK) {
								cell_under->color = cell->color;
								cell_under->type = cell->type;
								cell_under->mode = CM_FALL;
								cell_under->count = 0;
								cell->color = CC_BLANK;
								cel2_under->color = cel2->color;
								cel2_under->type = cel2->type;
								cel2_under->mode = CM_FALL;
								cel2_under->count = 0;
								cel2->color = CC_BLANK;
								result = 1;
							}
						}
						break;
					case CM_FALL:
						cel2 = cell + 1;
						cell->count += FALL_SPEED;
						cel2->count += FALL_SPEED;
						/* ... */
						if(cell->count >= 7) {
							/* ŉsłȂ΁Ap`FbNB */
							if(row < FIELD_ROWS - 1) {
								cell_under = cell + FIELD_COLS;
								cel2_under = cel2 + FIELD_COLS;
								/* ̃Z󂫂Ȃ΁ApB */
								if(cell_under->color == CC_BLANK &&
								   cel2_under->color == CC_BLANK) {
									cell_under->color = cell->color;
									cell_under->type = cell->type;
									cell_under->mode = CM_FALL;
									cell_under->count = cell->count - 7 - FALL_SPEED; /*()*/
									cell->color = CC_BLANK;
									cel2_under->color = cel2->color;
									cel2_under->type = cel2->type;
									cel2_under->mode = CM_FALL;
									cel2_under->count = cel2->count - 7 - FALL_SPEED; /*()*/
									cel2->color = CC_BLANK;
								} else {
									cell->mode = CM_BOUNCE;
									cell->count = 0;
									cel2->mode = CM_BOUNCE;
									cel2->count = 0;
								}
							} else {
								cell->mode = CM_BOUNCE;
								cell->count = 0;
								cel2->mode = CM_BOUNCE;
								cel2->count = 0;
							}
						}
						result = 1;
						break;
					case CM_BOUNCE:
						cel2 = cell + 1;
						cell->count++;
						cel2->count++;
						if(cell->count == 3) {
							cell->mode = CM_STOP;
							cel2->mode = CM_STOP;
						}
						result = 1;
						break;
					default:
						DIE();
					}
					break;
				case CT_RIGHT:
					/* ܂B */
					break;
				case CT_UPPER:
					switch(cell->mode) {
					case CM_STOP:
						/* ŉsłȂ΁AJn`FbNB */
						if(row < FIELD_ROWS - 2) {
							cel2 = cell + FIELD_COLS;
							cel2_under = cel2 + FIELD_COLS;
							/* ̉̃Z󂫂Ȃ΁AJnB */
							if(cel2_under->color == CC_BLANK) {
								cel2_under->color = cel2->color;
								cel2_under->type = cel2->type;
								cel2_under->mode = CM_FALL;
								cel2_under->count = 0;
								cel2->color = cell->color;
								cel2->type = cell->type;
								cel2->mode = CM_FALL;
								cel2->count = 0;
								cell->color = CC_BLANK;
							}
						}
						break;
					case CM_FALL:
						cel2 = cell + FIELD_COLS;
						cell->count += FALL_SPEED;
						cel2->count += FALL_SPEED;
						/* ... */
						if(cell->count >= 7) {
							/* ŉsłȂ΁Ap`FbNB */
							if(row < FIELD_ROWS - 2) {
								cel2_under = cel2 + FIELD_COLS;
								/* ̉̃Z󂫂Ȃ΁ApB */
								if(cel2_under->color == CC_BLANK) {
									cel2_under->color = cel2->color;
									cel2_under->type = cel2->type;
									cel2_under->mode = CM_FALL;
									cel2_under->count = cel2->count - 7 - FALL_SPEED; /*()*/
									cel2      ->color = cell->color;
									cel2      ->type = cell->type;
									cel2      ->mode = CM_FALL;
									cel2      ->count = cell->count - 7 - FALL_SPEED; /*()*/
									cell      ->color = CC_BLANK;
								} else {
									cell->mode = CM_BOUNCE;
									cell->count = 0;
									cel2->mode = CM_BOUNCE;
									cel2->count = 0;
								}
							} else {
								cell->mode = CM_BOUNCE;
								cell->count = 0;
								cel2->mode = CM_BOUNCE;
								cel2->count = 0;
							}
						}
						result = 1;
						break;
					case CM_BOUNCE:
						cel2 = cell + FIELD_COLS;
						cell->count++;
						cel2->count++;
						if(cell->count == 3) {
							cell->mode = CM_STOP;
							cel2->mode = CM_STOP;
						}
						result = 1;
						break;
					default:
						DIE();
					}
					break;
				case CT_UNDER:
					/* ܂B */
					break;
				default:
					DIE();
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	field_count
 ****************************************************************************/

/* TODO: xłBƂ悤B */
int
field_count(FIELD* field, char mark[FIELD_ROWS], int x, int y)
{
	int count, color;
	CELL* cell;

	cell = &field->cells[y][x];

	/* ̈ʒu}[N܂B */
	mark[y] |= 1 << x;

	/* PEEȂAJEg܂B */
	switch(cell->type) {
	case CT_SINGLE:
	case CT_LEFT:
	case CT_UPPER:
		count = 1;
		break;
	default:
		count = 0;
		break;
	}

	/* ㉺E̓F̃Z}[NEJEg܂B */
	color = cell->color;
	if(x > 0              && !(mark[y    ] & 1 << (x - 1)) && (cell - 1         )->color == color) {
		count += field_count(field, mark, x - 1, y    );
	}
	if(y > 0              && !(mark[y - 1] & 1 << (x    )) && (cell - FIELD_COLS)->color == color) {
		count += field_count(field, mark, x    , y - 1);
	}
	if(x < FIELD_COLS - 1 && !(mark[y    ] & 1 << (x + 1)) && (cell + 1         )->color == color) {
		count += field_count(field, mark, x + 1, y    );
	}
	if(y < FIELD_ROWS - 1 && !(mark[y + 1] & 1 << (x    )) && (cell + FIELD_COLS)->color == color) {
		count += field_count(field, mark, x    , y + 1);
	}

	return count;
}

/****************************************************************************
 *	field_erase_start
 ****************************************************************************/

static int diatom_check[2][6][2] = {
	{{-1, 0},{ 2, 0},{ 0,-1},{ 1,-1},{ 0, 1},{ 1, 1}}, /*CT_LEFT */
	{{-1, 0},{ 1, 0},{-1, 1},{ 1, 1},{ 0,-1},{ 0, 2}}, /*CT_UPPER*/
};
static int cube_check[4][2] = {
	{-1, 0},{ 1, 0},{ 0,-1},{ 0, 1},
};

int
field_erase_start(FIELD* field)
{
	int result, i, col, row, col2, row2, color, count, x_org, y_org;
	char mark[FIELD_ROWS];
	CELL (*cells)[FIELD_COLS], *cell, *cel2;

	/* RpCx}̂߁B */
	x_org = 0;
	y_org = 0;

	result = 0;
	switch(field->side) {
	case 0:
		x_org = FIELD_X0;
		y_org = FIELD_Y0;
		break;
	case 1:
		x_org = FIELD_X1;
		y_org = FIELD_Y1;
		break;
	default:
		DIE();
	}
	cells = field->cells;

	/* X[p[`FbN */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &cells[row][col];
			if(cell->color == CC_SUPER) {
				/* X[p[g̏ŊJnB */
				cell->mode = CM_ERASE;
				cell->count = 0;
				field->erase_num++; /*X[p[łɃJEg܂I*/
				result = 1; /*Œ*/
				/* X[p[̉Ɠ̏orJnB */
				if(row < FIELD_ROWS - 1) {
					color = cells[row + 1][col].color;
					if((color >= CC_WHITE && color <= CC_BLACK) || color == CC_CUBE) {
						for(row2 = 0; row2 < FIELD_ROWS; row2++) {
							for(col2 = 0; col2 < FIELD_COLS; col2++) {
								cel2 = &cells[row2][col2];
								if(cel2->color == color && cel2->mode == CM_STOP) {
									switch(cel2->type) {
									case CT_SINGLE:
										cel2->mode = CM_ERASE;
										cel2->count = 0;
										field->erase_num++; /*+1*/
										hamon_new(color != CC_CUBE ? 1 : 2,
											  x_org + col2 * 7 - 4,
											  y_org + row2 * 7 - 4);
										break;
									case CT_LEFT:
										 cel2     ->mode = CM_DIATOM;
										 cel2     ->count = 0;
										(cel2 + 1)->mode = CM_DIATOM;
										(cel2 + 1)->count = 0;
										/* ͏łɃJEgȂ */
										break;
									case CT_UPPER:
										 cel2              ->mode = CM_DIATOM;
										 cel2              ->count = 0;
										(cel2 + FIELD_COLS)->mode = CM_DIATOM;
										(cel2 + FIELD_COLS)->count = 0;
										/* ͏łɃJEgȂ */
										break;
									}
								}
							}
						}
					}
				}
			}
		}
	}

	/* Ń`FbNB */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &cells[row][col];
			switch(cell->color) {
			case CC_WHITE:
			case CC_LIGHT:
			case CC_DARK:
			case CC_BLACK:
				if(cell->mode == CM_STOP) {
					memset(mark, 0, sizeof mark);
					count = field_count(field, mark, col, row);
					if(count >= ERASE_COUNT) {
						for(row2 = 0; row2 < FIELD_ROWS; row2++) {
							for(col2 = 0; col2 < FIELD_COLS; col2++) {
								if(mark[row2] & 1 << col2) {
									cel2 = &cells[row2][col2];
									cel2->mode = CM_ERASE;
									cel2->count = 0;
									switch(cel2->type) {
									case CT_SINGLE:
									case CT_LEFT:
									case CT_UPPER:
										field->erase_num++; /*+1*/
										break;
										/* cE͈Ɛ */
									}
									hamon_new(1,
										  x_org + col2 * 7 - 4,
										  y_org + row2 * 7 - 4);
									result = 1; /*Œ*/
								}
							}
						}
					}
				}
				break;
			}
		}
	}

	/* łȂ΁AEL[ułȂ̂ŁAŋAB */
	if(!result) return result;

	/* EL[uŃ`FbNB */
	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &cells[row][col];
			if(cell->mode == CM_STOP) {
				switch(cell->color) {
				case CC_WHITE:
				case CC_LIGHT:
				case CC_DARK:
				case CC_BLACK:
					switch(cell->type) {
					case CT_LEFT:
						/* ׂŒʏorꂪłAJnB */
						for(i = 0; i < 6; i++) {
							col2 = col + diatom_check[0][i][0];
							row2 = row + diatom_check[0][i][1];
							if(0 <= col2 && col2 < FIELD_COLS &&
							   0 <= row2 && row2 < FIELD_ROWS &&
							   ((cells[row2][col2].color >= CC_WHITE &&
							     cells[row2][col2].color <= CC_BLACK) ||
							     cells[row2][col2].color == CC_SUPER) &&
							   cells[row2][col2].mode  == CM_ERASE) {
								cel2 = cell + 1;
								cell->mode = CM_DIATOM;
								cell->count = 0;
								cel2->mode = CM_DIATOM;
								cel2->count = 0;
								/* ͏łɃJEgȂ */
								break;
							}
						}
						break;
					case CT_UPPER:
						/* ׂŒʏorꂪłAJnB */
						for(i = 0; i < 6; i++) {
							col2 = col + diatom_check[1][i][0];
							row2 = row + diatom_check[1][i][1];
							if(0 <= col2 && col2 < FIELD_COLS &&
							   0 <= row2 && row2 < FIELD_ROWS &&
							   ((cells[row2][col2].color >= CC_WHITE &&
							     cells[row2][col2].color <= CC_BLACK) ||
							     cells[row2][col2].color == CC_SUPER) &&
							   cells[row2][col2].mode  == CM_ERASE) {
								cel2 = cell + FIELD_COLS;
								cell->mode = CM_DIATOM;
								cell->count = 0;
								cel2->mode = CM_DIATOM;
								cel2->count = 0;
								/* ͏łɃJEgȂ */
								break;
							}
						}
						break;
					}
					break;
				case CC_CUBE:
					/* ׂŒʏorꂪłAŊJnB */
					for(i = 0; i < 4; i++) {
						col2 = col + cube_check[i][0];
						row2 = row + cube_check[i][1];
						if(0 <= col2 && col2 < FIELD_COLS &&
						   0 <= row2 && row2 < FIELD_ROWS &&
						   ((cells[row2][col2].color >= CC_WHITE &&
						     cells[row2][col2].color <= CC_BLACK) ||
						     cells[row2][col2].color == CC_SUPER) &&
						   cells[row2][col2].mode  == CM_ERASE) {
							cell->mode = CM_ERASE;
							cell->count = 0;
							/* L[u͏łɃJEgȂ */
							hamon_new(2,
								  x_org + col * 7 - 4,
								  y_org + row * 7 - 4);
							break;
						}
					}
					break;
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	field_erase_iteration
 ****************************************************************************/

int
field_erase_iteration(FIELD* field)
{
	int result, col, row;
	CELL (*cells)[FIELD_COLS], *cell;

	result = 0;
	cells = field->cells;

	for(row = 0; row < FIELD_ROWS; row++) {
		for(col = 0; col < FIELD_COLS; col++) {
			cell = &cells[row][col];
			if(cell->color != CC_BLANK) {
				switch(cell->mode) {
				case CM_ERASE:
					cell->count++;
					if(cell->count == 2) {
						cell->color = CC_BLANK;
					}
					result = 1;
					break;
				case CM_DIATOM:
					cell->count++;
					if(cell->count == 2) {
						cell->type = CT_SINGLE;
						cell->mode = CM_STOP;
					}
					result = 1;
					break;
				}
			}
		}
	}

	return result;
}

/****************************************************************************
 *	field_init
 ****************************************************************************/

void
field_init(FIELD* field, int side)
{
	memset(field, 0, sizeof(FIELD));
	field->side = side;
}

/****************************************************************************
 *	field_proc
 ****************************************************************************/

/* o\ʒu */
static char ctrl_init_tbl[7] = { 3, 4, 2, 5, 1, 6, 0 };

/* A->L[u荞ݐ(񓖂) */
#define COMBO_MAX	16
static char combo_tbl[COMBO_MAX] = { 0,0,1,1, 2,2,3,4, 5,6,7,8, 9,10,11,12 };

/* 슮->Xs[h
 * F(7)傫Ȓlw肵Ă͂܂B
 *   1Zȏ̗ɂ͑ΉĂȂ̂ŁAُ퓮ƂȂ܂B
 */
static int spdtbl[][2] = {
	{  0, F(0.25) },
	{  5, F(0.5) },
	{ 10, F(1) },
	{ 15, F(2) },
	{ 20, F(4) },
	{ 25, F(7) },
	{ 30, F(1) },
	{ 35, F(2) },
	{ 40, F(4) },
	{ 45, F(7) },
};
#define N_SPDTBL	(sizeof spdtbl / sizeof *spdtbl)

/* E]^Cvϊ */
static char rot_tbl[2][5] = {
	/*CT_SINGLE CT_LEFT  CT_RIGHT CT_UPPER CT_UNDER*/
	{ CT_SINGLE,CT_UPPER,CT_UNDER,CT_RIGHT,CT_LEFT }, /*E]*/
	{ CT_SINGLE,CT_UNDER,CT_UPPER,CT_LEFT, CT_RIGHT}, /*]*/
};

/* n`n܂ł̎[] */
#define BOUNCE_TIME	SEC(0.55)

int
field_proc(FIELD* field, int pad)
{
	int retval, side, *cubes, i, j, n;
	CELL (*cells)[FIELD_COLS], (*quad)[2], *cell;

	side = field->side;
	cells = field->cells;
	quad = field->quad;
	cubes = field->cubes;

	switch(field->mode) {
	case FM_CTRL_INIT:
		/* ołȂL[uLZB */
		for(i = 0; i < FIELD_COLS; i++) cubes[i] = 0;

		/* AJEgNAB */
		field->combo = 0;

		/* Xs[hݒB */
		for(i = 0; i < N_SPDTBL; i++) {
			if(spdtbl[i][0] == field->ctrl_done) {
				field->speed = spdtbl[i][1];
				break;
			}
		}
		/* ȂA݂̗Xs[hێ܂B */

		/* o\ʒuT܂B */
		field->y = 0;
		for(i = 0; i < 7; i++) {
			field->x = ctrl_init_tbl[i];
			if(cells[field->y + 0][field->x + 0].color == CC_BLANK &&
			   cells[field->y + 0][field->x + 1].color == CC_BLANK &&
			   cells[field->y + 1][field->x + 0].color == CC_BLANK &&
			   cells[field->y + 1][field->x + 1].color == CC_BLANK) break;
		}
		if(i == 7) return 0; /* Q[I[o[ */

		/* Z擾܂B */
		next_get(field->quad);

		/* 䗎ֈڍs܂B */
		field->mode = FM_CTRL_FALL;
		field->count = 0;
		break;

	case FM_CTRL_FALL:
		/* ] */
		if(pad & TRG_A) {
			i = quad[0][0].color;			j = rot_tbl[0][(int)quad[0][0].type];
			quad[0][0].color = quad[1][0].color;	quad[0][0].type = rot_tbl[0][(int)quad[1][0].type];
			quad[1][0].color = quad[1][1].color;	quad[1][0].type = rot_tbl[0][(int)quad[1][1].type];
			quad[1][1].color = quad[0][1].color;	quad[1][1].type = rot_tbl[0][(int)quad[0][1].type];
			quad[0][1].color = i;			quad[0][1].type = j;
			sound_start(1 + field->side, CLICK3);
		}
		if(pad & TRG_B) {
			i = quad[0][0].color;			j = rot_tbl[1][(int)quad[0][0].type];
			quad[0][0].color = quad[0][1].color;	quad[0][0].type = rot_tbl[1][(int)quad[0][1].type];
			quad[0][1].color = quad[1][1].color;	quad[0][1].type = rot_tbl[1][(int)quad[1][1].type];
			quad[1][1].color = quad[1][0].color;	quad[1][1].type = rot_tbl[1][(int)quad[1][0].type];
			quad[1][0].color = i;			quad[1][0].type = j;
			sound_start(1 + field->side, CLICK3);
		}

		/* EړB */
		if(pad & TRG_LF) {
			if(field->x > 0 &&
			   cells[field->y + 0][field->x - 1].color == CC_BLANK &&
			   cells[field->y + 1][field->x - 1].color == CC_BLANK) {
				field->x--;
				sound_start(1 + field->side, CLICK3);
			}
		}
		if(pad & TRG_RI) {
			if(field->x < FIELD_COLS - 2 &&
			   cells[field->y + 0][field->x + 2].color == CC_BLANK &&
			   cells[field->y + 1][field->x + 2].color == CC_BLANK) {
				field->x++;
				sound_start(1 + field->side, CLICK3);
			}
		}

		/* B */
		if(pad & PAD_DN) {
			field->count += F(7);
		} else {
			field->count += field->speed;
		}
		if(field->count >= F(7)) {
			/* łȂ... */
			if(field->y < FIELD_ROWS - 2) {
				/* ̃Z󂫂Ȃ... */
				if(cells[field->y + 2][field->x + 0].color == CC_BLANK &&
				   cells[field->y + 2][field->x + 1].color == CC_BLANK) {
					/* pB */
					field->y++;
					field->count -= F(7);
				/* ̃Z󂫂łȂ... */
				} else {
					/* 䒅nֈڍs܂B */
					field->mode = FM_CTRL_BOUNCE;
					field->count = 0;
					sound_start(1 + field->side, CLICK1);
				}
			/* Ȃ... */
			} else {
				/* 䒅nֈڍs܂B */
				field->mode = FM_CTRL_BOUNCE;
				field->count = 0;
				sound_start(1 + field->side, CLICK1);
			}
		}
		break;

	case FM_CTRL_BOUNCE:
		/* ] */
		if(pad & TRG_A) {
			i = quad[0][0].color;			j = rot_tbl[0][(int)quad[0][0].type];
			quad[0][0].color = quad[1][0].color;	quad[0][0].type = rot_tbl[0][(int)quad[1][0].type];
			quad[1][0].color = quad[1][1].color;	quad[1][0].type = rot_tbl[0][(int)quad[1][1].type];
			quad[1][1].color = quad[0][1].color;	quad[1][1].type = rot_tbl[0][(int)quad[0][1].type];
			quad[0][1].color = i;			quad[0][1].type = j;
			sound_start(1 + field->side, CLICK3);
		}
		if(pad & TRG_B) {
			i = quad[0][0].color;			j = rot_tbl[1][(int)quad[0][0].type];
			quad[0][0].color = quad[0][1].color;	quad[0][0].type = rot_tbl[1][(int)quad[0][1].type];
			quad[0][1].color = quad[1][1].color;	quad[0][1].type = rot_tbl[1][(int)quad[1][1].type];
			quad[1][1].color = quad[1][0].color;	quad[1][1].type = rot_tbl[1][(int)quad[1][0].type];
			quad[1][0].color = i;			quad[1][0].type = j;
			sound_start(1 + field->side, CLICK3);
		}

		/* EړB */
		if(pad & TRG_LF) {
			if(field->x > 0 &&
			   cells[field->y + 0][field->x - 1].color == CC_BLANK &&
			   cells[field->y + 1][field->x - 1].color == CC_BLANK) {
				field->x--;
				sound_start(1 + field->side, CLICK3);
			}
		}
		if(pad & TRG_RI) {
			if(field->x < FIELD_COLS - 2 &&
			   cells[field->y + 0][field->x + 2].color == CC_BLANK &&
			   cells[field->y + 1][field->x + 2].color == CC_BLANK) {
				field->x++;
				sound_start(1 + field->side, CLICK3);
			}
		}

		/* łȂ... */
		if(field->y < FIELD_ROWS - 2) {
			/* (EړʁA)̃Z󂫂ɂȂ... */
			if(cells[field->y + 2][field->x + 0].color == CC_BLANK &&
			   cells[field->y + 2][field->x + 1].color == CC_BLANK) {
				/* ̃ZֈړāA䗎ֈڍs܂B
				 * (̃Zֈړ̂YƁAˏオĂ܂܂!)
				 */
				field->y++;
				field->mode = FM_CTRL_FALL;
				field->count = 0;
				break;
				/* n܂ł̃JEgAbvւ͍sȂB */
			}
		}

		/* n܂ł̃JEgAbvB */
		field->count += F(1);
		if(field->count >= F(BOUNCE_TIME)) {
			/* tB[hɊi[܂B */
			for(i = 0; i < 2; i++) {
				for(j = 0; j < 2; j++) {
					cell = &cells[field->y + i][field->x + j];
					cell->color = quad[i][j].color;
					cell->type = quad[i][j].type;
					cell->mode = CM_STOP;
				}
			}

			/* 䊮񐔂𑝂₵܂B */
			field->ctrl_done++;

			/* ֈڍsB */
			field->mode = FM_FALL;
			field->count = 0;
		}
		break;

	case FM_FALL:
		retval = field_fall_iteration(field);
		if(!retval) {
			/* łH */
			retval = field_erase_start(field);
			if(retval) {
				/* AJEgAbvB */
				field->combo++;
				if(field->combo > field->combo_max) { /* őAXV */
					field->combo_max = field->combo;
				}
				if(field->combo >= 3) { /* 3AȏȂ\ */
					t_combo(field->combo);
				}
				if(field->combo < 3) {
					sound_start(1 + field->side, BOMB1);
				} else if(field->combo < 6) {
					sound_start(1 + field->side, BOMB2);
				} else {
					sound_start(1 + field->side, BOMB3);
				}

				/* łֈڍsB */
				field->mode = FM_ERASE;
				field->count = 0;
			} else {
				/* AmAL[u荞݁B */
				if(field->combo > COMBO_MAX) {
					n = combo_tbl[COMBO_MAX - 1];
				} else {
					n = combo_tbl[field->combo];
				}
				for(i = 0; i < FIELD_COLS; i++) {
					fields[side ^ 1].cubes[i] += n;
				}

				/* L[uoֈڍsB */
				field->mode = FM_CUBE_FALL;
				field->count = 0;
			}
		}
		break;

	case FM_ERASE:
		retval = field_erase_iteration(field);
		if(!retval) {
			/* ֈڍsB */
			field->mode = FM_FALL;
			field->count = 0;
		}
		break;

	case FM_CUBE_FALL:
		/* L[uoB */
		for(i = 0; i < FIELD_COLS; i++) {
			cell = &cells[0][i];
			if(cubes[i] != 0 && cell->color == CC_BLANK) {
				cell->color = CC_CUBE;
				cell->type = CT_SINGLE;
				cell->mode = CM_STOP;
				cubes[i]--;
			}
		}

		/* L[uB */
		retval = field_fall_iteration(field);
		if(!retval) {
			/* 䏉ֈڍsB */
			field->mode = FM_CTRL_INIT;
			field->count = 0;
		}
	}

	return 1;
}

/****************************************************************************
 *	field_think
 ****************************************************************************/

int
field_think(FIELD* field)
{
	/* TODO: */
	return field->side == 0 ? pad : PAD_DN;
}
