/*
 *	next.c
 */
#include "app.h"

/****************************************************************************
 *	NEXTZ\^XN
 ****************************************************************************/

typedef struct _TASKDATA {
	int count;	/* Aj[VJE^ */
} TASKDATA;

static int
next_work(TASK* task)
{
	TASKDATA* data = (TASKDATA*)(task + 1);

	if(data->count < 0) {
		sprite_block(SPR_NEXTB, 54, 0 + data->count, CHR_NEXTB, 3, 3);
		quad_draw(SPR_NEXT, 56, 4 + data->count, next);
		data->count++;
	} else if(BTST(state, STATE_NEXT)) {
		sprite_block(SPR_NEXTB, 54, 0 + data->count, CHR_NEXTB, 3, 3);
		quad_draw(SPR_NEXT, 56, 4 + data->count, next);
	} else {
		sprite_block(SPR_NEXTB, 54, 0 - data->count, CHR_NEXTB, 3, 3);
		quad_draw(SPR_NEXT, 56, 4 - data->count, next);
		data->count++;
	}
	return 1;
}

TASK*
t_next()
{
	TASK* task;
	TASKDATA* data;

	task = task_new(game_task, sizeof(TASKDATA));
	task->work = next_work;

	data = (TASKDATA*)(task + 1);
	data->count = -24;

	BSET(state, STATE_NEXT);

	return task;
}
