/*
 *	ranking.c
 */
#include "app.h"

/****************************************************************************
 *	[Jϐ
 ****************************************************************************/

/* LOf[^̏lB */
static RANKING_DATA initial_ranking_data = {
	/* gCA */
	{ { 4, "PCE" },
	  { 4, "PCE" },
	  { 3, "PCE" },
	  { 3, "PCE" },
	  { 2, "PCE" },
	  { 2, "PCE" },
	  { 1, "PCE" },
	  { 1, "PCE" } },
	/* og */
	{ { SEC(173), "PCE" },
	  { SEC(174), "PCE" },
	  { SEC(175), "PCE" },
	  { SEC(176), "PCE" },
	  { SEC(177), "PCE" },
	  { SEC(178), "PCE" },
	  { SEC(179), "PCE" },
	  { SEC(180), "PCE" } },
};

/* Z[u`B
 * ƂŁALOȊOɂZ[uڂA
 * Z[u/[h͕ʊ֐ɕ邩܂B
 */
typedef struct _SRAM_DATA {
	RANKING_DATA ranking_data;
	/* ɒǉ */
} SRAM_DATA;
typedef struct _SRAM {
	int crc32;
	SRAM_DATA data;
} SRAM;

/* : 6܂! */
#define MAKER_NAME	"nsawa"
#define SOFT_NAME	"aomid"
#define KEY_NAME	"sram"

/****************************************************************************
 *	ranking_init
 ****************************************************************************/

void
ranking_init()
{
	int retval, i;
	SRAM sram;

	/* SRAMǂݍ݂̈ʏB */
	retval = regOpen(MAKER_NAME, SOFT_NAME);
	if(retval != 0) goto ERR1;
	retval = regReadKey(KEY_NAME, (char*)&sram);
	if(retval != 0) goto ERR2;
	pceCRC32(NULL, 0); /*Yꂸ!*/
	retval = pceCRC32(&sram.data, sizeof(SRAM_DATA));
	if(sram.crc32 != retval) goto ERR2;
	regClose();

	/* LOf[^Rs[܂B */
	memcpy(&ranking_data, &sram.data.ranking_data, sizeof(RANKING_DATA));

	return; /*Yꂸ! */

ERR2:
	regClose();
ERR1:
	/* lݒ肵܂B */
	memcpy(&ranking_data, &initial_ranking_data, sizeof(RANKING_DATA));

	/* G[bZ[W\B */
	bg_clear(0);
	bg_clear(1);
	bg_print(0, 0, 0, "SRAM LOAD ERROR");
	for(i = 0; i < SEC(1); i++) period();
	bg_clear(0);
	bg_clear(1);
}

/****************************************************************************
 *	ranking_exit
 ****************************************************************************/

void
ranking_exit()
{
	int retval, i;
	SRAM sram;

	/* LOf[^Rs[܂B */
	memcpy(&sram.data.ranking_data, &ranking_data, sizeof(RANKING_DATA));

	/* SRAM݂̈ʏB */
	pceCRC32(NULL, 0); /*Yꂸ!*/
	sram.crc32 = pceCRC32(&sram.data, sizeof(SRAM_DATA));
	retval = regOpen(MAKER_NAME, SOFT_NAME);
	if(retval != 0) goto ERR1;
	retval = regWriteKey(KEY_NAME, (char*)&sram, sizeof(SRAM));
	if(retval != 0) goto ERR2;
	regClose();

	return; /*Yꂸ! */

ERR2:
	regClose();
ERR1:
	/* G[bZ[W\B */
	bg_clear(0);
	bg_clear(1);
	bg_print(0, 0, 0, "SRAM SAVE ERROR");
	for(i = 0; i < SEC(1); i++) period();
	bg_clear(0);
	bg_clear(1);
}

/****************************************************************************
 *	ranking
 ****************************************************************************/

#define RANKING_TIMEOUT		SEC(5)

void
ranking(int type)
{
	int count, i, y;
	RANK *ranks, *rank;

	ranks = NULL; /*RpCx}*/

	BSET(state, STATE_RANKING);
	BSET(state, STATE_REVERSE);

	bg_clear_all(0);
	bg_clear_all(1);
	sprite_clear_all();

	switch(type) {
	case 0:
		bg_print(0, 1, 0, " TRIAL RANKING");
		ranks = ranking_data.trial;
		break;
	case 1:
		bg_print(0, 1, 0, "BATTLE RANKING");
		ranks = ranking_data.battle;
		break;
	default:
		DIE();
	}

	y = 2;
	for(i = 0, rank = ranks; i < N_RANKS; i++, rank++) {
		switch(type) {
		case 0:
			bg_print(0, 3, y, rank->name);
			bg_printf(0, 8, y, "%2dݻ", rank->score);
			break;
		case 1:
			bg_print(0, 2, y, rank->name);
			bg_print(0, 6, y, time_str(rank->score));
			break;
		default:
			DIE();
		}
		y++;
	}

	for(count = 0; count < RANKING_TIMEOUT; count++) {
		if(pad & TRG_A) break;
		period();
	}
	period();

	bg_clear_all(0);
	bg_clear_all(1);
	sprite_clear_all();

	BCLR(state, STATE_REVERSE);
	BCLR(state, STATE_RANKING);
}

/****************************************************************************
 *	nameentry
 ****************************************************************************/

void
nameentry(int type, int score)
{
	int count, i, y, i_rank;
	RANK *ranks, *rank;

	i_rank = 0; /*RpCx}*/
	ranks = NULL; /*RpCx}*/
	rank = NULL; /*RpCx}*/

	switch(type) {
	case 0:
		ranks = ranking_data.trial;
		for(i = 0, rank = ranks; i < N_RANKS; i++, rank++) {
			if(rank->score < score) break;
		}
		if(i == N_RANKS) return; /* NO */
		i_rank = i;
		break;
	case 1:
		ranks = ranking_data.battle;
		for(i = 0, rank = ranks; i < N_RANKS; i++, rank++) {
			if(rank->score > score) break;
		}
		if(i == N_RANKS) return; /* NO */
		i_rank = i;
		break;
	default:
		DIE();
	}

	BSET(state, STATE_NAMEENTRY);
	BSET(state, STATE_REVERSE);

	bg_clear_all(0);
	bg_clear_all(1);
	sprite_clear_all();

	rank = ranks + i_rank;
	memmove(rank + 1, rank, sizeof(RANK) * (N_RANKS - 1 - i_rank));
	rank->score = score;
	memset(rank->name, ' ', 3); /* ܂OB */

	/* SN\B */
	bg_print(0, 3, 0, "NAME ENTRY");
	y = 2;
	for(i = 0, rank = ranks; i < N_RANKS; i++, rank++) {
		switch(type) {
		case 0:
			bg_print(0, 3, y, rank->name);
			bg_printf(0, 8, y, "%2dݻ", rank->score);
			break;
		case 1:
			bg_print(0, 2, y, rank->name);
			bg_print(0, 6, y, time_str(rank->score));
			break;
		default:
			DIE();
		}
		y++;
	}

	/* TODO: ŖO܂! */
	rank = ranks + i_rank;
	y = 2 + i_rank;
	strcpy(rank->name, "YOU"); /*  */

	/* OA\B */
	for(count = 0; count < RANKING_TIMEOUT; count++) {
		if(timer % 7 < 5) {
			switch(type) {
			case 0:
				bg_print(0, 3, y, rank->name);
				bg_printf(0, 8, y, "%2dݻ", rank->score);
				break;
			case 1:
				bg_print(0, 2, y, rank->name);
				bg_print(0, 6, y, time_str(rank->score));
				break;
			default:
				DIE();
			}
		} else {
			bg_print(0, 0, y, "                ");
		}
		if(pad & TRG_A) break;
		period();
	}
	period();

	bg_clear_all(0);
	bg_clear_all(1);
	sprite_clear_all();

	BCLR(state, STATE_REVERSE);
	BCLR(state, STATE_NAMEENTRY);
}
