/*
 *	wipe.c
 */
#include "app.h"

typedef struct _TASKDATA {
	short type;	/* 0:CvAEg/1:CvC */
	short count;	/* Aj[VJE^ */
} TASKDATA;

/* Aj[Vp^[ */
static short chr_wipe[9] = {
	0,
	CHR_WIPE0, CHR_WIPE1, CHR_WIPE2, CHR_WIPE3,
	CHR_WIPE4, CHR_WIPE5, CHR_WIPE6, CHR_WIPE7,
};

void
wipe_free(TASK* task)
{
	BCLR(state, STATE_WIPE);
}

int
wipe_work(TASK* task)
{
	TASKDATA* data = (TASKDATA*)(task + 1);
	int x, y;
	short chr;

	if(data->count < 0 || 9 <= data->count) return 0;

	chr = chr_wipe[data->count];
	for(y = 0; y < 11; y++) {
		for(x = 0; x < 16; x++) {
			pclSpriteBGSetCharacter(1, x, y, chr);
		}
	}

	if(data->type == 0) {
		data->count++;
	} else {
		data->count--;
	}

	return 1;
}

TASK*
t_wipe(int type)
{
	TASK* task;
	TASKDATA* data;

	task = task_new(root_task, sizeof(TASKDATA));
	task->free = wipe_free;
	task->work = wipe_work;

	data = (TASKDATA*)(task + 1);
	data->type = type;
	if(type == 0) {
		data->count = 0;
		sound_start(3, WIPEOUT);
	} else {
		data->count = 9 - 1;
		sound_start(3, WIPEIN);
	}

	BSET(state, STATE_WIPE);

	return task;
}

